//+------------------------------------------------------------------+
//|                                                        Angel.mq4 |
//|                                         Copyright  2007, Angela |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Idea by Angela. Realization by Rebus"
#property link      ""
//====================================================================
// 
// T - /    -
// C - /  
//====================================================================
/*
#import "IdleLib.dll"         //   
int GetLastKeyWP();           //      
int IdleLibInit();
int IdleLibUnInit();
string GetActiveWndName();
*/

extern string ExpertProp="---    ---";
extern bool Trade=true;       //  
extern bool ShowParam=false;  //       
extern bool CalcPivot=true;   //    
extern bool ShowLabels=false; //   
extern string PivotProp="---    ---";
extern int Distance=46;       //    
extern int MinMaxPeriod=7;    //       
extern int Delta=5;           //      
extern int Inside=85;         //      
extern double Pivot=0;        //     
extern string OrdersProp="---      ---";
extern double Size=0.01;       //  ;  0,      
extern bool AutoCalcPos=true; //    
extern double Risk=0.2;       //     
extern int Magic=031408;      //    
extern int OrdersNumber=3;    //     -   !
extern int ProfitStep=20;     //   TP 
extern string IndicatorsProp="---      ---";
extern int PeriodJMA=7;       //  JMA

int BuyTickets[5];            //===================================== 
int SellTickets[5];           //     

int BuyTP[5];                 //   
int SellTP[5];                // 

double UpLine, DnLine;        //    
double LastPivot;             //    
bool NextPivot=true;          //     
int BO, SO;                   //   Buy  Sell
double Spread;                // 
static double LastOpenPrice;  //   

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
//   IdleLibInit();             // Dll    
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
//   IdleLibUnInit();   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   int i, k, se;              //  
   double p;         
   double LHigh, LLow;        //  MinMaxPeriod 
   static int KeyTrigger=0;   //   
   int LastKey;               //    
   string LastWnd;            //   Metatrader   
   static bool Trigger;
   static datetime StartTime; //    
   double JMA0, JMA1, JMA2, JMA3;

//-------------------------------------------
//  
//-------------------------------------------
//     
//-------------------------------------------
   if(Bars<100 && se==0)
   {
      Print("     100");
      se++;  
   }
//    
   if(IsDllsAllowed()==false)
   {
      Print("     .");
      se++;  
   }
   if(IsLibrariesAllowed()==false)
   {
      Print("  .");
      se++;  
   }
//       
//      se   
// ,    
   if(se>0) return(0);

//  
   Spread=Ask-Bid;

// 
//   JMA0=iCustom(NULL,0,"JMA",PeriodJMA,100,300,0,0);
//   JMA1=iCustom(NULL,0,"JMA",PeriodJMA,100,300,0,1);
//   JMA2=iCustom(NULL,0,"JMA",PeriodJMA,100,300,0,2);
//   JMA3=iCustom(NULL,0,"JMA",PeriodJMA,100,300,0,3);

//      
   if(OrdersTotal()==0)
   {
      NextPivot=true;
      BO=0;
      SO=0;
   }
   else
      NextPivot=false;

/*
//  
   if(BO>0 
      && JMA1>LastOpenPrice 
      && (High[1]+Low[1]+Close[1])/3<(High[0]+Low[0]+Close[0])/3
      && Bid>LastOpenPrice)
      CloseAllOrders(1);

   if(SO>0 
      && JMA1<LastOpenPrice 
      && (High[1]+Low[1]+Close[1])/3>(High[0]+Low[0]+Close[0])/3
      && Ask<LastOpenPrice)
      CloseAllOrders(-1);
*/

   if(CalcPivot==true && NextPivot==true) 
   //    
   //        MinMaxPeriod  2*Distance
   {
      LHigh=High[iHighest(NULL,0,MODE_HIGH,MinMaxPeriod,0)];
      LLow=Low[iLowest(NULL,0,MODE_LOW,MinMaxPeriod,0)];
      //   ,     
      for(i=0; i<MinMaxPeriod; i++)
         if(Low[i]<=(LHigh+LLow)/2+Delta*Point && High[i]>=(LHigh+LLow)/2-Delta*Point) k++;
         //    
         if((LHigh-LLow)<2*Distance*Point 
            && k/MinMaxPeriod>Inside/100
            && Low[0]<=(LHigh+LLow)/2
            && High[0]>=(LHigh+LLow)/2)
         {
            p=0;
            for(i=0; i<MinMaxPeriod; i++)
               p=p+(High[i]+Low[i])/2;  
               //    
            Pivot=NormalizeDouble(p/MinMaxPeriod,Digits);
         }
      }
     
   if(Pivot>0) 
   //     ,     
   {
      UpLine=NormalizeDouble(Pivot+Distance*Point+Spread,Digits);
      DnLine=NormalizeDouble(Pivot-Distance*Point,Digits);
      ShowPivot();
      CalcOrders();

      if(AutoCalcPos==true) Size=PosSize();

      if(Ask>UpLine
         && Ask<UpLine+5*Point
         && BO==0 
         && iCCI(NULL,0,70,PRICE_MEDIAN,1)>10) 
//      if(iCCI(NULL,0,70,PRICE_MEDIAN,1)<=0 && iCCI(NULL,0,70,PRICE_MEDIAN,0)>100) 
      {
         OpenBuyOrders(OrdersNumber);
         CalcOrders();
         StartTime=TimeCurrent();
      }
      if(Bid<DnLine 
         && Bid>DnLine-5*Point
         && SO==0 
         && iCCI(NULL,0,70,PRICE_MEDIAN,1)<-10) 
//      if(iCCI(NULL,0,70,PRICE_MEDIAN,1)>=-0 && iCCI(NULL,0,70,PRICE_MEDIAN,0)<-100) 
      {
         OpenSellOrders(OrdersNumber);
         CalcOrders();
         StartTime=TimeCurrent();
      }
      
      if(Pivot!=LastPivot) LastPivot=Pivot;
   }
   else
   //         
   {
      UpLine=0;
      DnLine=0;
      ObjectDelete("Pivot");
      ObjectDelete("UpLine");
      ObjectDelete("DnLine");
      ObjectDelete("Pivot label");
      ObjectDelete("UpLine label");
      ObjectDelete("DnLine label");
   }            

//   
   OrdersRest();
   
//     
   if(OrdersTotal()>0)
   {
      Comment(" : Buy ",BO,", Sell ",SO);
      Trigger=true;
   }
   else if(Trigger==true)
   {
      Comment(" : Buy ",BO,", Sell ",SO);
      Trigger=false;
   }

//     
   if((BO>0 && BO<=OrdersNumber-2) || (SO>0 && SO<=OrdersNumber-2)) Pivot=0;

/*
//      
   LastKey=GetLastKeyWP();
   LastWnd=GetActiveWndName();

   if((LastKey!=0) && (LastWnd!=""))
   {
      if(KeyTrigger!=LastKey) KeyTrigger=LastKey; 
      else 
      {
         LastKey=0; 
         KeyTrigger=0; 
      }

// Print(""+LastKey);
      
      switch(LastKey)
      {
         case 84:   //  T - /  
         {
            if(ShowParam==true) 
            {
               Comment("   .");
               ShowParam=false;
            }
            else 
            {
               Comment("   .");
               ShowParam=true;
            }
            break;
         }       
         case 67:   //  C - /  
         {
            CloseAllOrders(0);
            Pivot=0;
            UpLine=0;
            DnLine=0;
            BO=0;
            SO=0;
            Comment("");
            break;
         }
         case 77:   //  M -    
         {
            Comment("Buy: ",BuyTickets[0],", Sell: ",SellTickets[0],"\n",
                    "Buy: ",BuyTickets[1],", Sell: ",SellTickets[1],"\n",
                    "Buy: ",BuyTickets[2],", Sell: ",SellTickets[2],"\n",
                    "Buy: ",BuyTickets[3],", Sell: ",SellTickets[3],"\n",
                    "Buy: ",BuyTickets[4],", Sell: ",SellTickets[4],"\n");
            break;
         }
         case 33:   //  PgUp -    
         {
            Pivot=Pivot+Point;
            ShowPivot();
            break;
         }         
         case 34:   //  PgDn -    
         {
            Pivot=Pivot-Point;
            ShowPivot();
            break;
         }                    
         case 80:   //  P -       
         {
            Pivot=Bid;
            ShowPivot();
            break;
         }                    
         default : break;
      }
   }
*/
   return(0);
}
//+------------------------------------------------------------------+
//====================================================================
// 
//====================================================================
//    
//====================================================================
void ShowPivot()
{
   ObjectDelete("Pivot");
   ObjectCreate("Pivot",OBJ_HLINE,0,CurTime(),Pivot);
   ObjectSet("Pivot",OBJPROP_COLOR,Lime);
   ObjectSet("Pivot",OBJPROP_WIDTH,2);
   ObjectSet("Pivot",OBJPROP_STYLE,STYLE_SOLID);

   ObjectDelete("UpLine");
   ObjectCreate("UpLine",OBJ_HLINE,0,CurTime(),UpLine);
   ObjectSet("UpLine",OBJPROP_COLOR,Aqua);
   ObjectSet("UpLine",OBJPROP_STYLE,STYLE_DOT);

   ObjectDelete("DnLine");
   ObjectCreate("DnLine",OBJ_HLINE,0,CurTime(),DnLine);
   ObjectSet("DnLine",OBJPROP_COLOR,Red);
   ObjectSet("DnLine",OBJPROP_STYLE,STYLE_DOT);

   ObjectsRedraw();

   if(ShowLabels==true)
   {
      if(ObjectFind("Pivot label")!=0)
      {
         ObjectCreate("Pivot label",OBJ_TEXT,0,Time[0],Pivot);
         ObjectSetText("Pivot label","  ",7,"Arial",Lime);
      }
      else ObjectMove("Pivot label",0,Time[0],Pivot);
      if(ObjectFind("UpLine label")!=0)
      {
         ObjectCreate("UpLine label",OBJ_TEXT,0,Time[0],UpLine);
         ObjectSetText("UpLine label"," Buy ",7,"Arial",Aqua);
      }
      else ObjectMove("UpLine label",0,Time[0],UpLine);
      if(ObjectFind("DnLine label")!=0)
      {
         ObjectCreate("DnLine label",OBJ_TEXT,0,Time[0],DnLine);
         ObjectSetText("DnLine label"," Sell ",7,"Arial",Red);
      }
      else ObjectMove("DnLine label",0,Time[0],DnLine);
   }
}

//====================================================================
//   
//====================================================================
void CalcOrders()
{
   int i, SpreadPoint;
   
   SpreadPoint=MathRound(Spread/Point);
   
   BuyTP[0]=ProfitStep;
   BuyTP[1]=BuyTP[0]*2;
   for(i=2; i<=5; i++)
       BuyTP[i]=BuyTP[i-1]+BuyTP[0];

   for(i=0; i<5; i++)
      SellTP[i]=BuyTP[i]+SpreadPoint;

   string Header, BuyOrders, SellOrders;
   Header="              TP"+"\n";
   BuyOrders=StringConcatenate("B1:  ",BuyTP[0],"  ",DoubleToStr(UpLine+BuyTP[0]*Point,Digits),"\n",
                               "B2:  ",BuyTP[1],"  ",DoubleToStr(UpLine+BuyTP[1]*Point,Digits),"\n",
                               "B3:  ",BuyTP[2],"  ",DoubleToStr(UpLine+BuyTP[2]*Point,Digits),"\n",
                               "B4:  ",BuyTP[3],"  ",DoubleToStr(UpLine+BuyTP[3]*Point,Digits),"\n",
                               "B5:  ",BuyTP[4],"  ",DoubleToStr(UpLine+BuyTP[4]*Point,Digits),"\n");
   SellOrders=StringConcatenate("S1:  ",SellTP[0],"  ",DoubleToStr(DnLine+SellTP[0]*Point,Digits),"\n",
                                "S2:  ",SellTP[1],"  ",DoubleToStr(DnLine+SellTP[1]*Point,Digits),"\n",
                                "S3:  ",SellTP[2],"  ",DoubleToStr(DnLine+SellTP[2]*Point,Digits),"\n",
                                "S4:  ",SellTP[3],"  ",DoubleToStr(DnLine+SellTP[3]*Point,Digits),"\n",
                                "S5:  ",SellTP[4],"  ",DoubleToStr(DnLine+SellTP[4]*Point,Digits),"\n");
   
   if(ShowParam==true 
      && Ask<UpLine 
      && Bid>DnLine
      && Pivot!=LastPivot
     ) 
      Comment(Header, BuyOrders, SellOrders);       
}

//====================================================================
//     
//====================================================================
void OrdersRest()
{
   int i, total;

   total=OrdersTotal();

   BO=0;
   SO=0;
   if(total>0)
      for(i=total-1; i>=0; i--)
      {
         OrderSelect(i, SELECT_BY_POS, MODE_TRADES); 
         switch (OrderType())
         {
            case OP_BUY:
               BO++;
               break;
            case OP_SELL: 
               SO++;
               break;
            default: break;
         }             
      }  
}

/*
//====================================================================
//   
//====================================================================
void CloseAllOrders(int type)
{
   int i, total;

   total=OrdersTotal();

   for(i=total-1; i>=0; i--)
   {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()==OP_BUY && type>=0)
      //  Buy
         if(OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet)==true)
            Print(" : ",OrderTicket());
         else
         {
            Comment("  : ", OrderTicket());
            Print("  : ", OrderTicket());
            return(0);
         }
      if(OrderType()==OP_SELL && type<=0)
      //  Sell
         if(OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet)==true)
            Print(" : ",OrderTicket());
         else
         {
            Comment("  : ", OrderTicket());
            Print("  : ", OrderTicket());
            return(0);
         }
      if(OrderType()==OP_BUYSTOP || OrderType()==OP_SELLSTOP)
      //   
         if(OrderDelete(OrderTicket())==false)
         {
            Comment("  : ", OrderTicket());
            Print("  : ", OrderTicket());
            return(0);
         }
      }
}  
*/

//====================================================================
//   Buy
//====================================================================
void OpenBuyOrders(int OpenOrders)
{
   int i, total;

   if(AccountFreeMargin()<(10000*Size))
   {
      Comment("   .   = ", AccountFreeMargin());
 //     return(0);  
   }   

   total=OrdersTotal();
   if(total<1)
   //   
   {
      for(i=0; i<OpenOrders; i++)
         if(BuyTP[i]==0 || SellTP[i]==0)
         {
            Comment("   ,    .");
            return(0);
         }

      for(i=0; i<OpenOrders; i++)
      //     Buy
      {
         BuyTickets[i]=OrderSend(Symbol(),OP_BUY,Size,UpLine,5,0,UpLine+BuyTP[i]*Point,"Angel",Magic,0,Aqua);
         if(BuyTickets[i]>0)
         {
            if(OrderSelect(BuyTickets[i],SELECT_BY_TICKET,MODE_TRADES))
            {
               Print("BUY  : ",OrderOpenPrice());
               LastOpenPrice=OrderOpenPrice();
            }
            else Print("   BUY: ",GetLastError());
         }
      }
   }
   else
      Comment("  : "+total+",    .");
}

//====================================================================
//   Sell
//====================================================================
void OpenSellOrders(int OpenOrders)
{
   int i, total;

   if(AccountFreeMargin()<(10000*Size))
   {
      Comment("   .   = ", AccountFreeMargin());
//      return(0);  
   }   

   total=OrdersTotal();
   if(total<1)
   //   
   {
      for(i=0; i<OpenOrders; i++)
         if(BuyTP[i]==0 || SellTP[i]==0)
         {
            Comment("   ,    .");
            return(0);
         }

      for(i=0; i<OpenOrders; i++)
      //     Sell
      {
         SellTickets[i]=OrderSend(Symbol(),OP_SELL,Size,DnLine,5,0,DnLine-SellTP[i]*Point,"Angel",Magic,0,Red);
         if(SellTickets[i]>0)
         {
            if(OrderSelect(SellTickets[i],SELECT_BY_TICKET,MODE_TRADES))
            {
               Print("SELL  : ",OrderOpenPrice());
               LastOpenPrice=OrderOpenPrice();
            }
            else Print("   SELL: ",GetLastError());
         }
      }
   }
   else
      Comment("  : "+total+",    .");
}

//====================================================================
//    
//====================================================================
double PosSize()
{
   double L;
   
   L=0.1;
   L=NormalizeDouble(AccountFreeMargin()*Risk/1000.0/OrdersNumber,2);
   if(L>5)
      { 
       if(IsTesting()) L=5;
       else L=MarketInfo("EURUSD",MODE_MAXLOT);
      }
   if(L<0.1) L=0.1;
   return(L);
}